
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Purchase_order_line_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const purchase_order_line_items = await db.purchase_order_line_items.create(
            {
                id: data.id || undefined,
        
        description: data.description
        ||
        null
            ,
            
        quantity_ordered: data.quantity_ordered
        ||
        null
            ,
            
        quantity_received: data.quantity_received
        ||
        null
            ,
            
        unit_cost: data.unit_cost
        ||
        null
            ,
            
        line_total: data.line_total
        ||
        null
            ,
            
        sort_order: data.sort_order
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await purchase_order_line_items.setPurchase_order( data.purchase_order || null, {
            transaction,
        });
        
        await purchase_order_line_items.setMaterial( data.material || null, {
            transaction,
        });
        

        

        

        return purchase_order_line_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const purchase_order_line_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                description: item.description
            ||
            null
            ,
            
                quantity_ordered: item.quantity_ordered
            ||
            null
            ,
            
                quantity_received: item.quantity_received
            ||
            null
            ,
            
                unit_cost: item.unit_cost
            ||
            null
            ,
            
                line_total: item.line_total
            ||
            null
            ,
            
                sort_order: item.sort_order
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const purchase_order_line_items = await db.purchase_order_line_items.bulkCreate(purchase_order_line_itemsData, { transaction });

        // For each item created, replace relation files
        

        return purchase_order_line_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const purchase_order_line_items = await db.purchase_order_line_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.quantity_ordered !== undefined) updatePayload.quantity_ordered = data.quantity_ordered;
        
        
        if (data.quantity_received !== undefined) updatePayload.quantity_received = data.quantity_received;
        
        
        if (data.unit_cost !== undefined) updatePayload.unit_cost = data.unit_cost;
        
        
        if (data.line_total !== undefined) updatePayload.line_total = data.line_total;
        
        
        if (data.sort_order !== undefined) updatePayload.sort_order = data.sort_order;
        
        
        updatePayload.updatedById = currentUser.id;

        await purchase_order_line_items.update(updatePayload, {transaction});

        
        
        if (data.purchase_order !== undefined) {
            await purchase_order_line_items.setPurchase_order(
              
              data.purchase_order,
              
              { transaction }
            );
        }
        
        if (data.material !== undefined) {
            await purchase_order_line_items.setMaterial(
              
              data.material,
              
              { transaction }
            );
        }
        

        
        

        

        return purchase_order_line_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const purchase_order_line_items = await db.purchase_order_line_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of purchase_order_line_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of purchase_order_line_items) {
                await record.destroy({transaction});
            }
        });


        return purchase_order_line_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const purchase_order_line_items = await db.purchase_order_line_items.findByPk(id, options);

        await purchase_order_line_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await purchase_order_line_items.destroy({
            transaction
        });

        return purchase_order_line_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const purchase_order_line_items = await db.purchase_order_line_items.findOne(
            { where },
            { transaction },
        );

        if (!purchase_order_line_items) {
            return purchase_order_line_items;
        }

        const output = purchase_order_line_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.purchase_order = await purchase_order_line_items.getPurchase_order({
            transaction
        });
        
        
        output.material = await purchase_order_line_items.getMaterial({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.purchase_orders,
        as: 'purchase_order',
        
        where: filter.purchase_order ? {
          [Op.or]: [
            { id: { [Op.in]: filter.purchase_order.split('|').map(term => Utils.uuid(term)) } },
            {
              po_number: {
                [Op.or]: filter.purchase_order.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.materials,
        as: 'material',
        
        where: filter.material ? {
          [Op.or]: [
            { id: { [Op.in]: filter.material.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.material.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'purchase_order_line_items',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.quantity_orderedRange) {
                const [start, end] = filter.quantity_orderedRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity_ordered: {
                    ...where.quantity_ordered,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity_ordered: {
                    ...where.quantity_ordered,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.quantity_receivedRange) {
                const [start, end] = filter.quantity_receivedRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity_received: {
                    ...where.quantity_received,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity_received: {
                    ...where.quantity_received,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.unit_costRange) {
                const [start, end] = filter.unit_costRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    unit_cost: {
                    ...where.unit_cost,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    unit_cost: {
                    ...where.unit_cost,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.line_totalRange) {
                const [start, end] = filter.line_totalRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    line_total: {
                    ...where.line_total,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    line_total: {
                    ...where.line_total,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.sort_orderRange) {
                const [start, end] = filter.sort_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.purchase_order_line_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'purchase_order_line_items',
                        'description',
                        query,
                    ),
                ],
            };
        }

        const records = await db.purchase_order_line_items.findAll({
            attributes: [ 'id', 'description' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['description', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.description,
        }));
    }

    
};

